#
# I must be nuts... JNOS port to Linux
# Needless to say, this is just begging for trouble
#
# Why this instead of WAMPES?  I want a nice, strict firewall between the
# packet users and the rest of the system.  Unfortunately, WAMPES spawns login
# for all incoming connects (and doesn't work too nicely with DOS versions,
# since they default to line mode and local echo) and expects the system to
# provide services such as SMTP.  Sorry guys, I won't buy it....
#
# ++bsa kf8nh@kf8nh.wariat.org 01/19/93
#

CC = gcc -static
RM = rm -f
AR = ar rcs

#
# Known patches are:
#
# -DNO_STRTOUL		System has no strtoul()
# -DNO_GETTOD		System uses ftime() instead of gettimeofday()
# -DNO_STRCASECMP	We must supply strcasecmp()
# -DNO_STRNCASECMP	The former is POSIX; the latter is not???
# -DLITTLE_ENDIAN	Intel byte ordering, vs. Motorola
# -DBSAHAX		If you define this and you're not KF8NH, you're dead
#			(this protects my work-in-progress and experimental
#			hacks from being accidentally invoked by the unwary)
#
# SCO needs NO_STRTOUL, NO_GETTOD, NO_STRCASECMP, NO_STRNCASECMP, LITTLE_ENDIAN
# Linux needs LITTLE_ENDIAN
# Be aware that the non-LITTLE_ENDIAN code has not yet been tested; and there
# are *no* definitions for thread switching on such systems.
#
PATCHES = -DLITTLE_ENDIAN

#
# Your curses library.  Linux wants ncurses; System V wants curses; BSD wants
# curses, termcap, and major work to substitute for missing features in BSD
# curses.  (Or install Linux ncurses.)
#
LCURSES = -lncurses

#
# Warnings --- disable for less noise, enable for more certainty :-)  gcc will
# whine about things like partly bracketed initializers if you specify -W, but
# this can be ignored unless you're trying to port JNOS to VMS....
#
#WARNINGS = -W -Wimplicit -Wreturn-type -Wunused -Wswitch -Wpointer-arith \
#	   -Wcast-qual -Wcast-align -Waggregate-return -Wno-parentheses \
#	   -Wstrict-prototypes -Wmissing-prototypes -Wno-uninitialized

CFLAGS = -DLINUX -DUNIX -g3 -fno-inline $(PATCHES) $(WARNINGS)

all:    nos

hardware.h: linux.h
	cp linux.h hardware.h

CLIENTS= telnet.o ftpcli.o finger.o smtpcli.o hop.o \
        tip.o nntpcli.o popcli.o dialer.o rlogin.o callcli.o \
        mailcli.o pop2cli.o pop3cli.o rdate.o

SERVERS= ttylink.o ftpserv.o smisc.o smtpserv.o convers.o \
        nntpserv.o fingerd.o mboxcmd.o mailbox.o mailbox2.o mailfor.o \
        bmutil.o popserv.o forward.o tipmail.o mailutil.o \
        expire.o calldbd.o buckbook.o pop2serv.o pop3serv.o timed.o

BOOTP=	bootp.o bootpd.o bootpcmd.o bootpdip.o

INTERNET= tcpcmd.o tcpuser.o tcptimer.o tcpout.o tcpin.o \
	tcpsubr.o tcphdr.o udpcmd.o udp.o udphdr.o \
	domain.o domhdr.o ripcmd.o rip.o \
	ipcmd.o ip.o iproute.o iphdr.o \
	icmpcmd.o icmp.o icmpmsg.o icmphdr.o \
	arpcmd.o arp.o arphdr.o rarp.o \
	netuser.o rspf.o rspfcmd.o rspfhdr.o

AX25=   ax25cmd.o ax25user.o ax25.o axheard.o ax25aar.o \
	lapbtime.o lapb.o kiss.o ax25subr.o ax25hdr.o ax25mail.o

NETROM=	nrcmd.o nr4user.o nr4timer.o nr4.o nr4subr.o nr4hdr.o \
	nr3.o nrs.o nrhdr.o nr4mail.o

PPP=	asy.o ppp.o pppcmd.o pppfsm.o ppplcp.o \
	ppppap.o pppipcp.o pppdump.o \
	slhc.o slhcdump.o slip.o

NET=	ftpsubr.o sockcmd.o sockuser.o socket.o sockutil.o  \
	iface.o timer.o ttydriv.o cmdparse.o \
	mbuf.o misc.o pathname.o audit.o files.o  \
	kernel.o ksubr.o getopt.o wildmat.o lzw.o \
	getline.o devparam.o

DUMP= 	trace.o enetdump.o arcdump.o rspfdump.o  \
	kissdump.o ax25dump.o arpdump.o nrdump.o rwhodump.o \
	ipdump.o icmpdump.o udpdump.o tcpdump.o ripdump.o

# at and xmodem, at least, don't really belong here....
LINUX=	linux.o lxasy.o dirutil.o at.o lcsum.o curses.o xmodem.o glob.o

nos: main.o config.o version.o session.o clients.a servers.a internet.a \
    net.a netrom.a ax25.a linux.a dump.a ppp.a bootp.a
	$(CC) -c $(CFLAGS) version.c
	$(CC) -o nos main.o config.o version.o session.o \
		clients.a servers.a internet.a net.a netrom.a ax25.a linux.a \
		dump.a ppp.a bootp.a $(LCURSES)

clean:
	$(RM) *.[oa] hardware.h

clients.a: $(CLIENTS)
	$(RM) clients.a
	$(AR) clients.a $(CLIENTS)

servers.a: $(SERVERS)
	$(RM) servers.a
	$(AR) servers.a $(SERVERS)

ppp.a: $(PPP)
	$(RM) ppp.a
	$(AR) ppp.a $(PPP)

bootp.a: $(BOOTP)
	$(RM) bootp.a
	$(AR) bootp.a $(BOOTP)

internet.a: $(INTERNET)
	$(RM) internet.a
	$(AR) internet.a $(INTERNET)

ax25.a: $(AX25)
	$(RM) ax25.a
	$(AR) ax25.a $(AX25)

netrom.a: $(NETROM)
	$(RM) netrom.a
	$(AR) netrom.a $(NETROM)

net.a: $(NET)
	$(RM) net.a
	$(AR) net.a $(NET)

dump.a: $(DUMP)
	$(RM) dump.a
	$(AR) dump.a $(DUMP)

linux.a: $(LINUX)
	$(RM) linux.a
	$(AR) linux.a $(LINUX)

deps: hardware.h
	sed '/^# If you put anything after this line/q' Makefile > Makefile.tmp
	# it would be nice if standard Make supported internal loops...
	for file in main.o config.o version.o session.o; do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(CLIENTS); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(SERVERS); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(BOOTP); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(INTERNET); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(AX25); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(NETROM); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(PPP); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(NET); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(DUMP); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	for file in $(LINUX); do \
	    $(CC) $(CFLAGS) -MM `basename $$file .o`.c >> Makefile.tmp; \
	done
	mv Makefile Makefile.bak
	mv Makefile.tmp Makefile

# If you put anything after this line, it will disappear.
main.o : main.c global.h config.h lxtime.h mbuf.h timer.h proc.h iface.h socket.h \
  sockaddr.h ip.h internet.h tcp.h netuser.h udp.h ax25.h lapb.h kiss.h enet.h \
  netrom.h nr4.h ftpcli.h ftp.h session.h hardware.h telnet.h dirutil.h tty.h \
  usock.h lzw.h cmdparse.h commands.h daemon.h devparam.h domain.h files.h main.h \
  mailbox.h tipmail.h remote.h trace.h mailutil.h smtp.h version.h 
config.o : config.c global.h config.h lxtime.h mbuf.h timer.h proc.h iface.h \
  socket.h sockaddr.h ip.h internet.h tcp.h netuser.h udp.h lapb.h ax25.h enet.h \
  kiss.h netrom.h nr4.h pktdrvr.h ppp.h slip.h slhc.h arp.h icmp.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h usock.h lzw.h cmdparse.h commands.h mailbox.h \
  tipmail.h mailcli.h daemon.h ax25mail.h nr4mail.h bootp.h rspf.h main.h trace.h 
version.o : version.c config.h global.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h version.h 
session.o : session.c global.h config.h lxtime.h mbuf.h proc.h timer.h ftpcli.h \
  ftp.h session.h hardware.h telnet.h dirutil.h icmp.h iface.h socket.h sockaddr.h \
  internet.h ip.h tty.h cmdparse.h rlogin.h commands.h main.h 
telnet.o : telnet.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h telnet.h session.h hardware.h ftpcli.h ftp.h dirutil.h tty.h commands.h \
  netuser.h 
ftpcli.o : ftpcli.c global.h config.h lxtime.h mbuf.h session.h proc.h timer.h \
  hardware.h ftpcli.h ftp.h dirutil.h telnet.h cmdparse.h tty.h socket.h sockaddr.h \
  commands.h netuser.h files.h 
finger.o : finger.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h netuser.h \
  commands.h tty.h 
smtpcli.o : smtpcli.c global.h config.h lxtime.h mbuf.h cmdparse.h proc.h timer.h \
  socket.h sockaddr.h lzw.h usock.h tcp.h iface.h internet.h ip.h netuser.h udp.h \
  netrom.h ax25.h lapb.h nr4.h smtp.h dirutil.h commands.h session.h hardware.h \
  ftpcli.h ftp.h telnet.h files.h 
hop.o : hop.c global.h config.h lxtime.h mbuf.h usock.h /usr/include/time.h \
  lzw.h proc.h timer.h tcp.h iface.h socket.h sockaddr.h internet.h ip.h netuser.h \
  udp.h netrom.h ax25.h lapb.h nr4.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h domain.h commands.h tty.h cmdparse.h icmp.h 
tip.o : tip.c global.h config.h lxtime.h mbuf.h proc.h timer.h iface.h socket.h \
  sockaddr.h lxasy.h asy.h tty.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h commands.h devparam.h 
nntpcli.o : nntpcli.c global.h config.h lxtime.h timer.h cmdparse.h commands.h \
  socket.h mbuf.h proc.h sockaddr.h usock.h lzw.h tcp.h iface.h internet.h ip.h \
  netuser.h udp.h netrom.h ax25.h lapb.h nr4.h smtp.h mailutil.h files.h 
popcli.o : popcli.c global.h config.h lxtime.h mbuf.h cmdparse.h proc.h timer.h \
  socket.h sockaddr.h netuser.h dirutil.h files.h 
dialer.o : dialer.c global.h config.h lxtime.h mbuf.h timer.h proc.h iface.h \
  socket.h sockaddr.h netuser.h lxasy.h asy.h tty.h session.h hardware.h ftpcli.h \
  ftp.h dirutil.h telnet.h cmdparse.h devparam.h icmp.h internet.h ip.h files.h \
  main.h trace.h 
rlogin.o : rlogin.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h tty.h commands.h \
  netuser.h 
callcli.o : callcli.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h netuser.h \
  commands.h tty.h 
mailcli.o : mailcli.c global.h config.h lxtime.h timer.h proc.h mbuf.h socket.h \
  sockaddr.h domain.h cmdparse.h files.h netuser.h mailcli.h daemon.h mailutil.h \
  smtp.h 
pop2cli.o : pop2cli.c global.h config.h lxtime.h timer.h proc.h mbuf.h netuser.h \
  socket.h sockaddr.h cmdparse.h files.h mailcli.h daemon.h mailutil.h smtp.h 
pop3cli.o : pop3cli.c global.h config.h lxtime.h timer.h proc.h mbuf.h netuser.h \
  socket.h sockaddr.h cmdparse.h files.h mailcli.h daemon.h mailutil.h smtp.h 
rdate.o : rdate.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h netuser.h \
  commands.h tty.h cmdparse.h 
ttylink.o : ttylink.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h telnet.h session.h hardware.h ftpcli.h ftp.h dirutil.h tty.h mailbox.h \
  ax25.h ip.h iface.h internet.h lapb.h tipmail.h commands.h 
ftpserv.o : ftpserv.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h ftp.h ftpserv.h dirutil.h files.h commands.h cmdparse.h 
smisc.o : smisc.c global.h config.h lxtime.h netuser.h socket.h mbuf.h proc.h \
  timer.h sockaddr.h remote.h smtp.h tcp.h iface.h internet.h ip.h nr4.h ax25.h \
  lapb.h commands.h hardware.h mailbox.h tipmail.h 
smtpserv.o : smtpserv.c global.h config.h lxtime.h mbuf.h cmdparse.h socket.h \
  proc.h timer.h sockaddr.h lzw.h usock.h tcp.h iface.h internet.h ip.h netuser.h \
  udp.h netrom.h ax25.h lapb.h nr4.h smtp.h commands.h dirutil.h mailbox.h tipmail.h \
  mailutil.h bm.h domain.h session.h hardware.h ftpcli.h ftp.h telnet.h files.h \
  nntp.h 
convers.o : convers.c global.h config.h lxtime.h mailbox.h timer.h ax25.h ip.h \
  mbuf.h iface.h proc.h socket.h sockaddr.h internet.h lapb.h tipmail.h netuser.h \
  pktdrvr.h cmdparse.h usock.h lzw.h tcp.h udp.h netrom.h nr4.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h files.h 
nntpserv.o : nntpserv.c global.h config.h lxtime.h mbuf.h cmdparse.h socket.h \
  proc.h timer.h sockaddr.h iface.h smtp.h commands.h dirutil.h ftp.h netuser.h \
  nntp.h session.h hardware.h ftpcli.h telnet.h files.h bm.h mailbox.h ax25.h \
  ip.h internet.h lapb.h tipmail.h mailutil.h lzw.h usock.h tcp.h udp.h netrom.h \
  nr4.h 
fingerd.o : fingerd.c global.h config.h lxtime.h files.h mbuf.h socket.h proc.h \
  timer.h sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h commands.h \
  mailbox.h ax25.h ip.h iface.h internet.h lapb.h tipmail.h 
mboxcmd.o : mboxcmd.c global.h config.h lxtime.h timer.h proc.h mbuf.h socket.h \
  sockaddr.h usock.h lzw.h tcp.h iface.h internet.h ip.h netuser.h udp.h netrom.h \
  ax25.h lapb.h nr4.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h smtp.h \
  ftpserv.h commands.h files.h bm.h mailbox.h tipmail.h mailutil.h pktdrvr.h ax25mail.h \
  nr4mail.h cmdparse.h mailfor.h 
mailbox.o : mailbox.c global.h config.h lxtime.h timer.h proc.h mbuf.h socket.h \
  sockaddr.h usock.h lzw.h tcp.h iface.h internet.h ip.h netuser.h udp.h netrom.h \
  ax25.h lapb.h nr4.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h smtp.h \
  ftpserv.h commands.h files.h bm.h mailbox.h tipmail.h mailutil.h pktdrvr.h ax25mail.h \
  nr4mail.h cmdparse.h mailfor.h 
mailbox2.o : mailbox2.c global.h config.h lxtime.h timer.h proc.h mbuf.h socket.h \
  sockaddr.h usock.h lzw.h tcp.h iface.h internet.h ip.h netuser.h udp.h netrom.h \
  ax25.h lapb.h nr4.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h smtp.h \
  ftpserv.h commands.h files.h bm.h mailbox.h tipmail.h mailutil.h pktdrvr.h ax25mail.h \
  nr4mail.h cmdparse.h mailfor.h authent.h 
mailfor.o : mailfor.c global.h config.h lxtime.h files.h dirutil.h bm.h mailbox.h \
  timer.h ax25.h ip.h mbuf.h iface.h proc.h socket.h sockaddr.h internet.h lapb.h \
  tipmail.h smtp.h mailutil.h cmdparse.h pktdrvr.h mailfor.h 
bmutil.o : bmutil.c global.h config.h lxtime.h ftpserv.h sockaddr.h timer.h \
  smtp.h proc.h mbuf.h usock.h lzw.h tcp.h iface.h socket.h internet.h ip.h netuser.h \
  udp.h netrom.h ax25.h lapb.h nr4.h telnet.h session.h hardware.h ftpcli.h ftp.h \
  dirutil.h files.h mailbox.h tipmail.h cmdparse.h bm.h mailutil.h 
popserv.o : popserv.c global.h config.h lxtime.h mbuf.h cmdparse.h socket.h \
  proc.h timer.h sockaddr.h files.h pop.h dirutil.h 
forward.o : forward.c global.h config.h lxtime.h bm.h mailbox.h timer.h ax25.h \
  ip.h mbuf.h iface.h proc.h socket.h sockaddr.h internet.h lapb.h tipmail.h smtp.h \
  mailutil.h cmdparse.h usock.h lzw.h tcp.h netuser.h udp.h netrom.h nr4.h files.h 
tipmail.o : tipmail.c global.h config.h lxtime.h mbuf.h timer.h proc.h iface.h \
  socket.h sockaddr.h lxasy.h asy.h usock.h /usr/include/time.h lzw.h tcp.h internet.h \
  ip.h netuser.h udp.h netrom.h ax25.h lapb.h nr4.h telnet.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h mailbox.h tipmail.h devparam.h 
mailutil.o : mailutil.c global.h config.h lxtime.h socket.h mbuf.h proc.h timer.h \
  sockaddr.h mailutil.h smtp.h files.h 
expire.o : expire.c global.h config.h lxtime.h timer.h proc.h mbuf.h bm.h mailbox.h \
  ax25.h ip.h iface.h socket.h sockaddr.h internet.h lapb.h tipmail.h smtp.h mailutil.h \
  files.h socket.c netuser.h tcp.h udp.h netrom.h nr4.h lzw.h usock.h 
calldbd.o : calldbd.c global.h config.h lxtime.h files.h mbuf.h socket.h proc.h \
  timer.h sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h commands.h \
  mailbox.h ax25.h ip.h iface.h internet.h lapb.h tipmail.h 
buckbook.o : buckbook.c global.h config.h lxtime.h files.h cmdparse.h ftp.h 
pop2serv.o : pop2serv.c global.h config.h lxtime.h mbuf.h cmdparse.h socket.h \
  proc.h timer.h sockaddr.h files.h smtp.h mailcli.h daemon.h dirutil.h 
pop3serv.o : pop3serv.c global.h config.h lxtime.h mbuf.h cmdparse.h socket.h \
  proc.h timer.h sockaddr.h files.h smtp.h dirutil.h 
timed.o : timed.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h 
bootp.o : bootp.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h netuser.h udp.h iface.h internet.h ip.h domain.h rip.h cmdparse.h \
  bootp.h 
bootpd.o : bootpd.c global.h config.h lxtime.h bootp.h socket.h mbuf.h proc.h \
  timer.h sockaddr.h cmdparse.h iface.h bootpd.h arp.h udp.h internet.h ip.h netuser.h 
bootpcmd.o : bootpcmd.c global.h config.h lxtime.h cmdparse.h bootpd.h socket.h \
  mbuf.h proc.h timer.h sockaddr.h arp.h iface.h netuser.h udp.h internet.h ip.h 
bootpdip.o : bootpdip.c global.h config.h lxtime.h arp.h mbuf.h iface.h proc.h \
  timer.h socket.h sockaddr.h netuser.h pktdrvr.h bootpd.h 
tcpcmd.o : tcpcmd.c global.h config.h lxtime.h timer.h mbuf.h netuser.h socket.h \
  proc.h sockaddr.h internet.h tcp.h iface.h ip.h cmdparse.h commands.h /usr/include/ctype.h 
tcpuser.o : tcpuser.c global.h config.h lxtime.h timer.h mbuf.h netuser.h socket.h \
  proc.h sockaddr.h internet.h tcp.h iface.h ip.h icmp.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h 
tcptimer.o : tcptimer.c global.h config.h lxtime.h mbuf.h timer.h netuser.h \
  socket.h proc.h sockaddr.h internet.h tcp.h iface.h ip.h 
tcpout.o : tcpout.c global.h config.h lxtime.h timer.h mbuf.h netuser.h socket.h \
  proc.h sockaddr.h internet.h tcp.h iface.h ip.h 
tcpin.o : tcpin.c global.h config.h lxtime.h timer.h mbuf.h netuser.h socket.h \
  proc.h sockaddr.h internet.h tcp.h iface.h ip.h icmp.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h 
tcpsubr.o : tcpsubr.c global.h config.h lxtime.h timer.h mbuf.h netuser.h socket.h \
  proc.h sockaddr.h internet.h tcp.h iface.h ip.h 
tcphdr.o : tcphdr.c global.h config.h lxtime.h mbuf.h tcp.h iface.h proc.h timer.h \
  socket.h sockaddr.h internet.h ip.h netuser.h 
udpcmd.o : udpcmd.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h udp.h iface.h internet.h ip.h cmdparse.h commands.h 
udp.o : udp.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h timer.h \
  sockaddr.h iface.h udp.h internet.h ip.h icmp.h session.h hardware.h ftpcli.h \
  ftp.h dirutil.h telnet.h 
udphdr.o : udphdr.c global.h config.h lxtime.h mbuf.h ip.h iface.h proc.h timer.h \
  socket.h sockaddr.h internet.h udp.h netuser.h 
domain.o : domain.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h ip.h iface.h internet.h cmdparse.h domain.h commands.h files.h \
  getline.h 
domhdr.o : domhdr.c global.h config.h lxtime.h mbuf.h domain.h proc.h timer.h 
ripcmd.o : ripcmd.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h internet.h cmdparse.h iface.h udp.h ip.h rip.h commands.h 
rip.o : rip.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h timer.h \
  sockaddr.h udp.h iface.h internet.h ip.h rip.h arp.h 
ipcmd.o : ipcmd.c global.h config.h lxtime.h mbuf.h internet.h timer.h netuser.h \
  socket.h proc.h sockaddr.h iface.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h ip.h cmdparse.h commands.h rip.h udp.h rspf.h domain.h pktdrvr.h 
ip.o : ip.c global.h config.h lxtime.h mbuf.h timer.h internet.h netuser.h socket.h \
  proc.h sockaddr.h iface.h pktdrvr.h ip.h icmp.h session.h hardware.h ftpcli.h \
  ftp.h dirutil.h telnet.h 
iproute.o : iproute.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h iface.h internet.h ip.h netuser.h icmp.h session.h hardware.h ftpcli.h \
  ftp.h dirutil.h telnet.h rip.h udp.h trace.h pktdrvr.h bootp.h 
iphdr.o : iphdr.c global.h config.h lxtime.h mbuf.h ip.h iface.h proc.h timer.h \
  socket.h sockaddr.h internet.h 
icmpcmd.o : icmpcmd.c global.h config.h lxtime.h icmp.h mbuf.h iface.h proc.h \
  timer.h socket.h sockaddr.h internet.h ip.h session.h hardware.h ftpcli.h ftp.h \
  dirutil.h telnet.h netuser.h cmdparse.h commands.h 
icmp.o : icmp.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h socket.h \
  sockaddr.h ip.h internet.h icmp.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h netuser.h 
icmpmsg.o : icmpmsg.c global.h config.h lxtime.h 
icmphdr.o : icmphdr.c global.h config.h lxtime.h mbuf.h internet.h ip.h iface.h \
  proc.h timer.h socket.h sockaddr.h icmp.h session.h hardware.h ftpcli.h ftp.h \
  dirutil.h telnet.h 
arpcmd.o : arpcmd.c global.h config.h lxtime.h mbuf.h timer.h internet.h ip.h \
  iface.h proc.h socket.h sockaddr.h enet.h ax25.h lapb.h arp.h netuser.h cmdparse.h \
  commands.h rspf.h domain.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h 
arp.o : arp.c global.h config.h lxtime.h mbuf.h timer.h iface.h proc.h socket.h \
  sockaddr.h enet.h ax25.h ip.h internet.h lapb.h icmp.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h arp.h rspf.h 
arphdr.o : arphdr.c global.h config.h lxtime.h mbuf.h arp.h iface.h proc.h timer.h \
  socket.h sockaddr.h 
rarp.o : rarp.c global.h config.h lxtime.h mbuf.h proc.h timer.h iface.h socket.h \
  sockaddr.h ax25.h ip.h internet.h lapb.h arp.h netuser.h cmdparse.h pktdrvr.h 
netuser.o : netuser.c global.h config.h lxtime.h netuser.h socket.h mbuf.h proc.h \
  timer.h sockaddr.h domain.h 
rspf.o : rspf.c global.h config.h lxtime.h mbuf.h proc.h timer.h netuser.h socket.h \
  sockaddr.h internet.h pktdrvr.h iface.h ip.h ax25.h lapb.h arp.h icmp.h session.h \
  hardware.h ftpcli.h ftp.h dirutil.h telnet.h rspf.h 
rspfcmd.o : rspfcmd.c global.h config.h lxtime.h mbuf.h timer.h iface.h proc.h \
  socket.h sockaddr.h cmdparse.h netuser.h rspf.h ip.h internet.h 
rspfhdr.o : rspfhdr.c global.h config.h lxtime.h mbuf.h internet.h ip.h iface.h \
  proc.h timer.h socket.h sockaddr.h rspf.h 
ax25cmd.o : ax25cmd.c global.h config.h lxtime.h mbuf.h timer.h proc.h iface.h \
  socket.h sockaddr.h ax25.h ip.h internet.h lapb.h cmdparse.h mailbox.h tipmail.h \
  session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h tty.h nr4.h commands.h \
  pktdrvr.h netrom.h 
ax25user.o : ax25user.c global.h config.h lxtime.h mbuf.h timer.h iface.h proc.h \
  socket.h sockaddr.h lapb.h ax25.h ip.h internet.h 
ax25.o : ax25.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h socket.h \
  sockaddr.h arp.h slip.h slhc.h ip.h internet.h tcp.h netuser.h ax25.h lapb.h \
  netrom.h nr4.h devparam.h trace.h pktdrvr.h commands.h 
axheard.o : axheard.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h ax25.h ip.h internet.h lapb.h 
ax25aar.o : ax25aar.c global.h config.h lxtime.h mbuf.h timer.h iface.h proc.h \
  socket.h sockaddr.h ax25.h ip.h internet.h lapb.h icmp.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h arp.h rip.h udp.h netuser.h 
lapbtime.o : lapbtime.c global.h config.h lxtime.h mbuf.h ax25.h ip.h iface.h \
  proc.h timer.h socket.h sockaddr.h internet.h lapb.h 
lapb.o : lapb.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h iface.h \
  proc.h socket.h sockaddr.h internet.h lapb.h netrom.h nr4.h 
kiss.o : kiss.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h socket.h \
  sockaddr.h kiss.h devparam.h slip.h slhc.h ip.h internet.h tcp.h netuser.h asy.h \
  ax25.h lapb.h pktdrvr.h 
ax25subr.o : ax25subr.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h \
  iface.h proc.h socket.h sockaddr.h internet.h lapb.h 
ax25hdr.o : ax25hdr.c global.h config.h lxtime.h mbuf.h ax25.h ip.h iface.h \
  proc.h timer.h socket.h sockaddr.h internet.h lapb.h 
ax25mail.o : ax25mail.c global.h config.h lxtime.h proc.h mbuf.h timer.h iface.h \
  socket.h sockaddr.h pktdrvr.h ax25.h ip.h internet.h lapb.h usock.h /usr/include/time.h \
  lzw.h tcp.h netuser.h udp.h netrom.h nr4.h session.h hardware.h ftpcli.h ftp.h \
  dirutil.h telnet.h mailbox.h tipmail.h ax25mail.h 
nrcmd.o : nrcmd.c config.h global.h lxtime.h mbuf.h ax25.h ip.h iface.h proc.h \
  timer.h socket.h sockaddr.h internet.h lapb.h mailbox.h tipmail.h netrom.h nr4.h \
  pktdrvr.h cmdparse.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h \
  commands.h files.h 
nr4user.o : nr4user.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h \
  iface.h proc.h socket.h sockaddr.h internet.h lapb.h netrom.h nr4.h 
nr4timer.o : nr4timer.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h \
  iface.h proc.h socket.h sockaddr.h internet.h lapb.h netrom.h nr4.h 
nr4.o : nr4.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h iface.h \
  proc.h socket.h sockaddr.h internet.h lapb.h netrom.h nr4.h cmdparse.h 
nr4subr.o : nr4subr.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h \
  iface.h proc.h socket.h sockaddr.h internet.h lapb.h netrom.h nr4.h 
nr4hdr.o : nr4hdr.c global.h config.h lxtime.h mbuf.h nr4.h timer.h ax25.h ip.h \
  iface.h proc.h socket.h sockaddr.h internet.h lapb.h 
nr3.o : nr3.c global.h config.h lxtime.h mbuf.h pktdrvr.h iface.h proc.h timer.h \
  socket.h sockaddr.h netuser.h arp.h slip.h slhc.h ip.h internet.h tcp.h ax25.h \
  lapb.h netrom.h nr4.h trace.h commands.h 
nrs.o : nrs.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h socket.h \
  sockaddr.h pktdrvr.h ax25.h ip.h internet.h lapb.h nrs.h asy.h trace.h commands.h 
nrhdr.o : nrhdr.c global.h config.h lxtime.h mbuf.h timer.h ax25.h ip.h iface.h \
  proc.h socket.h sockaddr.h internet.h lapb.h netrom.h nr4.h 
nr4mail.o : nr4mail.c global.h config.h lxtime.h proc.h mbuf.h timer.h netrom.h \
  iface.h socket.h sockaddr.h ax25.h ip.h internet.h lapb.h nr4.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h cmdparse.h commands.h mailbox.h tipmail.h \
  nr4mail.h 
asy.o : asy.c global.h config.h lxtime.h proc.h mbuf.h timer.h iface.h socket.h \
  sockaddr.h netuser.h slhc.h ip.h internet.h tcp.h lxasy.h asy.h ax25.h lapb.h \
  kiss.h pktdrvr.h ppp.h slip.h nrs.h commands.h 
ppp.o : ppp.c global.h config.h lxtime.h mbuf.h proc.h timer.h iface.h socket.h \
  sockaddr.h internet.h ip.h slhc.h tcp.h netuser.h lxasy.h asy.h pktdrvr.h devparam.h \
  ppp.h pppfsm.h ppplcp.h ppppap.h pppipcp.h trace.h 
pppcmd.o : pppcmd.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h pktdrvr.h ppp.h pppfsm.h ppplcp.h ppppap.h pppipcp.h slhc.h \
  ip.h internet.h tcp.h netuser.h cmdparse.h 
pppfsm.o : pppfsm.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h ppp.h pppfsm.h ppplcp.h trace.h 
ppplcp.o : ppplcp.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h ppp.h pppfsm.h ppplcp.h ppppap.h cmdparse.h devparam.h trace.h 
ppppap.o : ppppap.c global.h config.h lxtime.h mbuf.h proc.h timer.h iface.h \
  socket.h sockaddr.h session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h ppp.h \
  pppfsm.h ppplcp.h ppppap.h cmdparse.h files.h trace.h main.h 
pppipcp.o : pppipcp.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h slhc.h ip.h internet.h tcp.h netuser.h ppp.h pppfsm.h pppipcp.h \
  cmdparse.h files.h trace.h 
pppdump.o : pppdump.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h internet.h ppp.h trace.h 
slhc.o : slhc.c global.h config.h lxtime.h mbuf.h internet.h ip.h iface.h proc.h \
  timer.h socket.h sockaddr.h tcp.h netuser.h slhc.h 
slhcdump.o : slhcdump.c global.h config.h lxtime.h mbuf.h internet.h ip.h iface.h \
  proc.h timer.h socket.h sockaddr.h slhc.h tcp.h netuser.h trace.h 
slip.o : slip.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h socket.h \
  sockaddr.h ip.h internet.h slhc.h tcp.h netuser.h asy.h slip.h trace.h 
ftpsubr.o : ftpsubr.c global.h config.h lxtime.h mbuf.h socket.h proc.h timer.h \
  sockaddr.h ftp.h ftpcli.h session.h hardware.h telnet.h dirutil.h 
sockcmd.o : sockcmd.c global.h config.h lxtime.h mbuf.h proc.h timer.h lzw.h \
  usock.h /usr/include/time.h tcp.h iface.h socket.h sockaddr.h internet.h ip.h \
  netuser.h udp.h netrom.h ax25.h lapb.h nr4.h commands.h 
sockuser.o : sockuser.c global.h config.h lxtime.h mbuf.h proc.h timer.h socket.h \
  sockaddr.h lzw.h usock.h /usr/include/time.h tcp.h iface.h internet.h ip.h netuser.h \
  udp.h netrom.h ax25.h lapb.h nr4.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h 
socket.o : socket.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h iface.h ip.h internet.h tcp.h udp.h ax25.h lapb.h netrom.h \
  nr4.h lzw.h usock.h 
sockutil.o : sockutil.c global.h config.h lxtime.h mbuf.h netuser.h socket.h \
  proc.h timer.h sockaddr.h usock.h /usr/include/time.h lzw.h tcp.h iface.h internet.h \
  ip.h udp.h netrom.h ax25.h lapb.h nr4.h 
iface.o : iface.c global.h config.h lxtime.h mbuf.h proc.h timer.h iface.h socket.h \
  sockaddr.h ip.h internet.h netuser.h ax25.h lapb.h enet.h arp.h pktdrvr.h cmdparse.h \
  commands.h nr4.h mailbox.h tipmail.h 
timer.o : timer.c global.h config.h lxtime.h timer.h proc.h mbuf.h commands.h \
  daemon.h hardware.h socket.h sockaddr.h 
ttydriv.o : ttydriv.c global.h config.h lxtime.h mbuf.h session.h proc.h timer.h \
  hardware.h ftpcli.h ftp.h dirutil.h telnet.h tty.h socket.h sockaddr.h 
cmdparse.o : cmdparse.c global.h config.h lxtime.h proc.h mbuf.h timer.h cmdparse.h \
  session.h hardware.h ftpcli.h ftp.h dirutil.h telnet.h pktdrvr.h iface.h socket.h \
  sockaddr.h 
mbuf.o : mbuf.c global.h config.h lxtime.h mbuf.h proc.h timer.h 
misc.o : misc.c global.h config.h lxtime.h socket.h mbuf.h proc.h timer.h sockaddr.h 
pathname.o : pathname.c global.h config.h lxtime.h dirutil.h 
audit.o : audit.c global.h config.h lxtime.h mbuf.h 
files.o : files.c global.h config.h lxtime.h netuser.h socket.h mbuf.h proc.h \
  timer.h sockaddr.h files.h 
kernel.o : kernel.c global.h config.h lxtime.h mbuf.h proc.h timer.h socket.h \
  sockaddr.h daemon.h hardware.h 
ksubr.o : ksubr.c global.h config.h lxtime.h proc.h mbuf.h timer.h commands.h \
  socket.h sockaddr.h 
getopt.o : getopt.c global.h config.h lxtime.h 
wildmat.o : wildmat.c global.h config.h lxtime.h 
lzw.o : lzw.c global.h config.h lxtime.h mbuf.h proc.h timer.h lzw.h usock.h \
  /usr/include/time.h tcp.h iface.h socket.h sockaddr.h internet.h ip.h netuser.h \
  udp.h netrom.h ax25.h lapb.h nr4.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h cmdparse.h 
getline.o : getline.c global.h config.h lxtime.h 
devparam.o : devparam.c global.h config.h lxtime.h devparam.h 
trace.o : trace.c global.h config.h lxtime.h mbuf.h iface.h proc.h timer.h socket.h \
  sockaddr.h pktdrvr.h commands.h session.h hardware.h ftpcli.h ftp.h dirutil.h \
  telnet.h trace.h cmdparse.h slip.h slhc.h ip.h internet.h tcp.h netuser.h 
enetdump.o : enetdump.c global.h config.h lxtime.h mbuf.h enet.h iface.h proc.h \
  timer.h socket.h sockaddr.h trace.h 
arcdump.o : arcdump.c global.h config.h lxtime.h mbuf.h arcnet.h iface.h proc.h \
  timer.h socket.h sockaddr.h trace.h 
rspfdump.o : rspfdump.c global.h config.h lxtime.h mbuf.h netuser.h socket.h \
  proc.h timer.h sockaddr.h internet.h ip.h iface.h rspf.h trace.h 
kissdump.o : kissdump.c global.h config.h lxtime.h mbuf.h kiss.h iface.h proc.h \
  timer.h socket.h sockaddr.h devparam.h ax25.h ip.h internet.h lapb.h trace.h 
ax25dump.o : ax25dump.c global.h config.h lxtime.h mbuf.h ax25.h ip.h iface.h \
  proc.h timer.h socket.h sockaddr.h internet.h lapb.h trace.h 
arpdump.o : arpdump.c global.h config.h lxtime.h mbuf.h arp.h iface.h proc.h \
  timer.h socket.h sockaddr.h netuser.h trace.h 
nrdump.o : nrdump.c global.h config.h lxtime.h mbuf.h netrom.h iface.h proc.h \
  timer.h socket.h sockaddr.h ax25.h ip.h internet.h lapb.h nr4.h trace.h 
rwhodump.o : rwhodump.c global.h config.h lxtime.h mbuf.h trace.h iface.h proc.h \
  timer.h socket.h sockaddr.h 
ipdump.o : ipdump.c global.h config.h lxtime.h mbuf.h internet.h iface.h proc.h \
  timer.h socket.h sockaddr.h ip.h trace.h netuser.h 
icmpdump.o : icmpdump.c global.h config.h lxtime.h mbuf.h internet.h netuser.h \
  socket.h proc.h timer.h sockaddr.h icmp.h iface.h ip.h session.h hardware.h \
  ftpcli.h ftp.h dirutil.h telnet.h trace.h 
udpdump.o : udpdump.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h internet.h udp.h iface.h ip.h trace.h 
tcpdump.o : tcpdump.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h internet.h tcp.h iface.h ip.h trace.h 
ripdump.o : ripdump.c global.h config.h lxtime.h mbuf.h netuser.h socket.h proc.h \
  timer.h sockaddr.h rip.h iface.h udp.h internet.h ip.h trace.h 
linux.o : linux.c hardware.h global.h config.h lxtime.h timer.h proc.h mbuf.h \
  socket.h sockaddr.h 
lxasy.o : lxasy.c global.h config.h lxtime.h mbuf.h proc.h timer.h iface.h socket.h \
  sockaddr.h asy.h lxasy.h hardware.h devparam.h 
dirutil.o : dirutil.c global.h config.h lxtime.h proc.h mbuf.h timer.h session.h \
  hardware.h ftpcli.h ftp.h dirutil.h telnet.h commands.h 
at.o : at.c global.h config.h lxtime.h timer.h cmdparse.h socket.h mbuf.h proc.h \
  sockaddr.h 
lcsum.o : lcsum.c global.h config.h lxtime.h ip.h mbuf.h iface.h proc.h timer.h \
  socket.h sockaddr.h internet.h 
curses.o : curses.c hardware.h global.h config.h lxtime.h proc.h mbuf.h timer.h \
  socket.h sockaddr.h tty.h session.h ftpcli.h ftp.h dirutil.h telnet.h 
xmodem.o : xmodem.c global.h config.h lxtime.h dirutil.h timer.h socket.h mbuf.h \
  proc.h sockaddr.h mailbox.h ax25.h ip.h iface.h internet.h lapb.h tipmail.h 
glob.o : glob.c dirutil.h global.h config.h lxtime.h 
